<template>
  <q-page
    class="full-width col justify-center"
  >
    <!-- CASE SELECTION AND CASE CREATION BUTTON -->
    <div
      class="row q-pa-md"
    >
      <q-select
        ref="select"
        v-model="selectedCaseOption"
        class="col q-mr-md"
        outlined
        use-input
        hide-selected
        fill-input
        input-debounce="0"
        :options="filteredOptions"
        :loading="casesLoading"
        label="Search and select existing cases"
        @filter="filterOptions"
      >
        <template
          v-slot:option="option"
        >
          <q-item
            v-bind="option.itemProps"
            v-on="option.itemEvents"
          >
            <q-item-section>
              <q-item-label>{{ option.opt.label }}</q-item-label>
            </q-item-section>
          </q-item>
        </template>
      </q-select>
      <q-btn
        id="start-case-creation"
        class="q-pa-sm"
        outline
        color="primary"
        label="Create new Case"
        @click="showCaseCreation"
      />
    </div>
    <div>
      <case-creation
        ref="caseCreation"
        :creator-id="creatorId"
        :existing-local-ids="selectOptions"
        @created="createdCase($event)"
      />
    </div>
    <!-- CASE VIEW -->
    <div
      v-if="selectedCaseOption"
      class="col q-pa-sm"
    >
      <div
        class="text-h5 col q-pa-sm"
      >
        Case {{ selectedCaseOption.label }}
        <q-btn
          id="delete_case"
          outline
          style="color: black; float: right;"
          icon="delete"
          size="sm"
          dense
          @click="confirmDeletion=true"
        >
          <q-tooltip
            anchor="top middle"
            self="bottom middle"
            :offset="[15, 15]"
          >
            Delete Case
          </q-tooltip>
        </q-btn>
        <q-btn
          id="save_mappings"
          outline
          style="color: black; float: right;  margin-right: 5px;"
          icon="save_alt"
          size="sm"
          dense
          @click="$refs.slides.saveMappings()"
        >
          <q-tooltip
            anchor="top middle"
            self="bottom middle"
            :offset="[15, 15]"
          >
            Save mappings (ID to original name)
          </q-tooltip>
        </q-btn>
      </div>
      <q-input
        v-model="description"
        outlined
        label="Description"
        class="col q-pa-sm"
        @input="update"
      />
    </div>
    <!-- SLIDES AND SLIDE SEARCH AND SLIDE UPLOAD -->
    <div
      v-if="selectedCaseOption"
      class="col q-pa-sm"
    >
      <div class="text-h5 col q-pa-sm">
        Slides
      </div>
      <div
        class="row q-pa-sm"
      >
        <q-input
          v-model="searchSlide"
          class="col q-mr-md"
          debounce="500"
          outlined
          placeholder="Search for a slide by entering its original filename or ID"
        >
          <template v-slot:append>
            <q-icon name="search" />
          </template>
        </q-input>
        <q-btn
          id="start-file-uploader"
          class="q-pa-sm"
          outline
          color="primary"
          label="Add new slide"
          @click="showSlideUploader"
        />
      </div>
      <slides
        ref="slides"
        :local-case-id="selectedCaseOption.label"
        :creator-id="creatorId"
        :case-id="globalCaseId"
        :search-slide="searchSlide"
        :upload-manager="selectedUploadManager"
      />
    </div>
    <!-- DIALOG TO CONFIRM CASE DELETION -->
    <q-dialog
      v-if="selectedCaseOption"
      v-model="confirmDeletion"
      persistent
    >
      <q-card>
        <q-card-section class="row items-center">
          <q-avatar
            icon="delete"
            color="red"
            text-color="white"
          />
          <span class="q-ml-md">Do you really want to delete case <b>{{ selectedCaseOption.label }}</b> including all slides?</span>
        </q-card-section>

        <q-card-actions align="right">
          <q-btn
            v-close-popup
            flat
            label="Cancel"
            color="primary"
          />
          <q-btn
            id="confirm_delete_case"
            v-close-popup
            flat
            label="Confirm"
            color="red"
            @click="deleteCase"
          />
        </q-card-actions>
      </q-card>
    </q-dialog>
  </q-page>
</template>

<script>
import { debounce } from 'quasar'
import idm from '../mixins/idm_api'
import mds from '../mixins/mds_api'
import Slides from './Slides.vue'
import CaseCreation from './dialogs/CaseCreation.vue'
import { UploadManager } from '../mixins/uploads'
import { addSlideFromFinishedUpload } from '../mixins/slides'
import EventBus from '../mixins/event_bus'

export default {
  name: 'Cases',
  components: {
    slides: Slides,
    caseCreation: CaseCreation
  },
  props: {
    caseId: {
      type: String,
      default: ''
    },
    creatorId: {
      type: String,
      default: 'default_user'
    }
  },
  data () {
    return {
      selectedCaseOption: null,
      selectOptions: [],
      filteredOptions: [],
      selectedUploadManager: null,
      uploadManagers: {},
      description: null,
      localCaseId: null,
      globalCaseId: null,
      confirmDeletion: false,
      searchSlide: null,
      dismissConnectionIssue: null,
      uploadProgress: null,
      casesLoading: true
    }
  },
  watch: {
    $route (route) {
      this.caseId = route.params.caseId
      this.openCase()
    },
    selectedCaseOption: async function (selectedCaseOption) {
      if (selectedCaseOption !== null) {
        const selectedCase = await mds.getCase(selectedCaseOption.value)
        this.description = selectedCase.description
        const path = `/cases/${selectedCaseOption.value}`
        if (this.$route.path !== path) this.$router.push(path)
        this.globalCaseId = selectedCaseOption.value
        if (!(this.globalCaseId in this.uploadManagers)) {
          this.$set(this.uploadManagers, this.globalCaseId, new UploadManager())
          const localCaseId = selectedCaseOption.label
          const globalCaseId = selectedCaseOption.value
          const handleUploadedFile = async function (upload) {
            const ids = await addSlideFromFinishedUpload(upload, localCaseId)
            if (this.selectedCaseOption.label === localCaseId) {
              this.$refs.slides.addSlide(ids[0])
            } else {
              this.notifyDone(`Finished upload of slide ${ids[1]} (Case: ${localCaseId})`, 1000)
            }
            this.uploadManagers[globalCaseId].remove(upload)
          }.bind(this)
          this.uploadManagers[this.globalCaseId].setUploadFinishedCallback(handleUploadedFile)
          const connectionIssueCallback = () => {
            this.dismissConnectionIssue = this.$q.notify({
              timeout: 0,
              type: 'negative',
              message: 'Connection issues. Please check your internet connection and resume failed uploads.',
              icon: 'cloud_off',
              actions: [
                {
                  label: 'Resume',
                  color: 'white',
                  handler: () => {
                    this.resumeUploads()
                  }
                }
              ]
            })
          }
          this.uploadManagers[this.globalCaseId].setConnectionIssueCallback(connectionIssueCallback)
        }
        this.selectedUploadManager = this.uploadManagers[this.globalCaseId]
      }
    },
    uploadManagers: {
      handler () {
        let uploadedBytes = 0
        let totalUploadingBytes = 1
        const uploadingCases = []
        for (const selectOption of this.selectOptions) {
          const caseId = selectOption.value
          if (caseId in this.uploadManagers) {
            const uploadedBytesCase = this.uploadManagers[caseId].getUploadedBytes()
            const totalUploadingBytesCase = this.uploadManagers[caseId].getTotalBytesUploading()
            uploadedBytes += uploadedBytesCase
            totalUploadingBytes += totalUploadingBytesCase
            if (totalUploadingBytesCase > 0) {
              uploadingCases.push({
                id: selectOption.value,
                label: selectOption.label,
                progress: Math.round(100 * uploadedBytesCase / totalUploadingBytesCase)
              })
            }
          }
        }
        EventBus.$emit('upload-progress', Math.round(100 * uploadedBytes / totalUploadingBytes))
        EventBus.$emit('uploading-cases', uploadingCases)
      },
      deep: true
    }
  },
  async created () {
    this.init()
    this.update = debounce(this.update, 500)
    EventBus.$on('resume-uploads', () => {
      this.resumeUploads()
      if (this.dismissConnectionIssue) {
        this.dismissConnectionIssue()
      }
    })
    EventBus.$on('open-case', (caseId) => {
      this.openCase(caseId)
    })
  },
  methods: {
    async init () {
      this.selectedUploadManager = null
      this.selectedCaseOption = null
      await this.updateSelectOptions()
      this.openCase(this.caseId)
    },
    openCase (caseId) {
      const selectedCase = this.selectOptions.filter(
        caseOption => caseOption.value === caseId
      )
      if (selectedCase.length > 0) {
        this.selectedCaseOption = selectedCase[0]
      }
    },
    showCaseCreation () {
      this.$refs.caseCreation.showCaseCreation = true
    },
    showSlideUploader () {
      this.$refs.slides.showSlideUploader = true
    },
    async createdCase (caseId) {
      await this.updateSelectOptions()
      this.openCase(caseId)
      this.notifyDone(`Case ${this.selectedCaseOption.label} created`)
    },
    resumeUploads () {
      for (const caseId in this.uploadManagers) {
        this.uploadManagers[caseId].resume()
      }
    },
    async updateSelectOptions () {
      this.casesLoading = true
      const availableCases = (await mds.getAllCases()).filter(x => x.deleted !== true)
      const empaiaIds = availableCases.map(obj => obj.id)
      const mapping = await idm.getCaseIdMappingForEmpaiaIds(empaiaIds)
      const cases = []
      for (const Case of availableCases) {
        if (Case.id in mapping) {
          const option = {
            label: mapping[Case.id],
            value: Case.id
          }
          cases.push(option)
        } else {
          console.log(`Case ${Case.id} has no ID mapping and is ignored. This is probably due to incorrect case creation.`)
        }
      }
      this.selectOptions = cases
      this.filteredOptions = cases
      this.casesLoading = false
    },
    async deleteCase () {
      this.$q.loading.show({
        delay: 500 // ms
      })
      this.selectedUploadManager.cancel()
      delete this.uploadManagers[this.globalCaseId]
      await this.$refs.slides.deleteAllSlides()
      await mds.deleteCase(this.selectedCaseOption.value)
      await idm.deleteCase(this.selectedCaseOption.value)
      this.notifyDone(`Case ${this.selectedCaseOption.label} deleted`)
      this.init()
      this.$q.loading.hide()
    },
    async update () {
      await mds.updateCase(
        this.selectedCaseOption.value,
        this.description
      )
      this.notifyDone(`Case ${this.selectedCaseOption.label} updated`)
    },
    filterOptions (val, update, abort) {
      const needle = val.toLowerCase()
      this.filteredOptions = this.selectOptions.filter(v => v.label.toLowerCase().indexOf(needle) > -1)
      update(
        () => {
          const needle = val.toLowerCase()
          this.filteredOptions = this.selectOptions.filter(v => v.label.toLowerCase().indexOf(needle) > -1)
        },
        ref => {
          if (val !== '' && ref.options.length > 0) {
            ref.setOptionIndex(-1)
            ref.moveOptionSelection(1, true)
          }
        }
      )
    },
    notifyDone (message, timeout = 500) {
      this.$q.notify({
        color: 'green-4',
        textColor: 'white',
        icon: 'cloud_done',
        message: message,
        timeout: timeout
      })
    }
  }
}
</script>
